--[[
Author: Starinnia
CPR is a combo points display addon based on Funkydude's BasicComboPoints
Fulmination.lua - A module for tracking extra Lighning Shield stacks for the Fulmination talent
$Date: 2010-10-16 00:49:37 +0000 (Sat, 16 Oct 2010) $
$Revision: 150 $
Project Version: r155
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2007-2010 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(2, UnitClass("player")) ~= "SHAMAN" then return end

local cpr = LibStub("AceAddon-3.0"):GetAddon("ComboPointsRedux")
local modName = "Fulmination"
local FulminationModule = cpr:NewModule(modName, "AceConsole-3.0", "AceEvent-3.0")
local buff = GetSpellInfo(324)
FulminationModule.abbrev = "F"
FulminationModule.MAX_POINTS = 6
FulminationModule.displayName = GetSpellInfo(88766)

function FulminationModule:OnInitialize()
	self.graphics = cpr:MakeGraphicsFrame(modName, self.MAX_POINTS)
	self.text = cpr:MakeTextFrame(modName)
end

function FulminationModule:OnEnable()
	if not cpr.db.profile.modules[modName].disableGraphics then
		self.graphics:Show()
	end
	if not cpr.db.profile.modules[modName].disableText then
		self.text:Show()
	end
	
	self:RegisterEvent("UNIT_AURA")
end

function FulminationModule:OnDisable()
	self.graphics:Hide()
	self.text:Hide()
	self:UnregisterAllEvents()
end

function FulminationModule:UNIT_AURA(_, unit)
	if unit ~= "player" then return end
	
	local _, _, _, count = UnitBuff("player", buff)
	if count and count > 3 then
		count = count - 3
		local r, g, b = cpr:GetColorByPoints(modName, count)
		for i = count, 1, -1 do
			self.graphics.points[i].icon:SetVertexColor(r, g, b)
			self.graphics.points[i]:Show()
		end
		for j = self.MAX_POINTS, count+1, -1 do
			self.graphics.points[j]:Hide()
		end
		self.text:SetNumPoints(count)
	else
		for i = 1, self.MAX_POINTS do
			self.graphics.points[i]:Hide()
		end
		self.text:SetNumPoints("")
	end
end
